unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure affiche_jeu ;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const direction : array[1..8] of integer =
               (-11, -10, -9, -1, 1, 9, 10, 11);
      work0 : array[0..99] of byte =
               (8, 9,9,9,9,9,9,9,8, 8,

                8, 9,0,0,0,0,0,0,9, 9,
                9, 9,9,0,0,0,0,9,2, 9,
                9, 2,2,0,0,0,2,0,2, 9,
                9, 2,2,0,2,2,2,0,2, 9,
                9, 2,2,2,2,0,0,2,2, 9,
                9, 2,2,2,2,0,0,2,2, 9,
                9, 2,9,2,0,0,0,9,9, 9,
                9, 9,9,2,2,2,2,2,9, 9,

                9, 9,9,9,9,9,9,9,9, 9) ;

       COEF_ORDINATEUR      = -1 ;
       ORDINATEUR           =  0 ;
       COEF_JOUEUR          =  1 ;
       JOUEUR               =  2 ;

type   othellier            = array[0..99] of byte ;
       utile                = array[0..18] of integer;
       n_othelliers         = array[0..18] of othellier ;

var    work                 : othellier ;
       position             : utile ;
       temoin               : utile ;
       nb_coups             : utile ;
       tab_pense            : n_othelliers ;
       profondeur           : integer ;

function compte_les_pions(couleur : integer) : integer ;
var x,total_pions : integer ;
begin
x:=10 ;total_pions:=0 ;
repeat
  inc(x) ;
  if work[x]=couleur then inc(total_pions) ;
until x=88 ;
compte_les_pions:=total_pions ;
end ;


function trouve_pos(niveau,joueur : integer):integer ;
var a,xx,xv,opposant,delta : integer ;
begin
xx:=position[niveau] ;
trouve_pos:=0 ;
opposant:=2-joueur ;
repeat
   repeat
      inc(xx)
   until (work[xx]=9) or (xx>88) ;
   position[niveau]:=xx ;
   if ((1+xx) mod 10>1) and (xx<89) then
      for a:=1 to 8 do
          begin
          delta:=direction[a] ;
          if work[xx+delta]=opposant then
             begin
             xv:=xx+delta ;
             while work[xv]=opposant do
                inc(xv,delta) ;
             if work[xv]=joueur then
                begin
                trouve_pos:=xx ;
                exit
                end ;
             end ;
          end ;
until (xx>88) ;
end ;


procedure joue_coup(position_courante,joueur:integer) ;
var a,xx,opposant,delta : integer ;
begin
opposant:=2-joueur ;
for a:=1 to 8 do
    begin
    delta:=direction[a] ;
    xx:=position_courante+delta ;
    while work[xx]=opposant do
          inc(xx,delta) ;
    if work[xx]=joueur then
       repeat
          dec(xx,delta) ;
          work[xx]:=joueur ;
       until xx=position_courante ;
    end ;
for a:=1 to 8 do
    if work[position_courante+direction[a]]=8 then
       work[position_courante+direction[a]]:=9 ;
end ;


procedure arbre(c,level:integer) ;
var x,next,last : integer ;
begin
nb_coups[level]:=0 ;
position[level]:=10 ;
temoin[level]  :=c*25000 ;
temoin[level+1]:=-temoin[level] ;
next           :=level+1 ;
last           :=level-1 ;
repeat
  move(tab_pense[last],work,100) ;
  x:=trouve_pos(level,1+c) ;
  if x>0 then
     begin
     inc(nb_coups[level]) ;
     joue_coup(x,1+c) ;
     move(work,tab_pense[level],100) ;
     if profondeur<>level
        then arbre(-c,next)
        else temoin[next]:=compte_les_pions(ORDINATEUR) ;
     end
  else
     if nb_coups[level]=0 then
        if nb_coups[last]=0
           then temoin[level]:=compte_les_pions(ORDINATEUR)
           else begin
                move(work,tab_pense[level],100) ;
                inc(profondeur) ;
                arbre(-c,next) ;
                dec(profondeur) ;
                end ;
  case c of
   -1 : begin
        if temoin[level]<temoin[next] then temoin[level]:=temoin[next] ;
        if temoin[level]>temoin[last] then exit ;
        end ;
    1 : begin
        if temoin[level]>temoin[next] then temoin[level]:=temoin[next] ;
        if temoin[level]<temoin[last] then exit ;
        end ;
    end ;
until position[level]>88 ;
end ;


procedure niveau_un ;
var x,meilleur_coup,temoin1 : integer ;
begin
move(work,tab_pense[0],100) ;
meilleur_coup:=0 ;
nb_coups[1]:=0 ;
temoin[1]:=0 ;
position[1]:=10 ;
profondeur:=11 ;
repeat
  move(tab_pense[0],work,100) ;
  x:=trouve_pos(1,ORDINATEUR) ;
  if x>0 then
     begin
     inc(nb_coups[1]) ;
     if nb_coups[1]=1 then meilleur_coup:=x ;
     joue_coup(x,2) ;
     move(work,tab_pense[1],100) ;
     arbre(COEF_JOUEUR,2) ;
     temoin1:=temoin[1] ;
     if temoin[1]<temoin[2] then temoin[1]:=temoin[2] ;
     if temoin[1]>temoin1   then meilleur_coup:=position[1] ;
     end ;
until position[1]>88 ;
form1.memo1.lines.add('Le meilleur coup pour les noirs est '+inttostr(meilleur_coup)) ;
form1.memo1.lines.add('Il rapporte '+inttostr(temoin[1])+' pions noirs en fin de partie !') ;
end ;


procedure TForm1.Button2Click(Sender: TObject);
begin
close ;
end;

procedure tform1.affiche_jeu ;
var x,y : integer ;
begin
for x:=1 to 8 do
for y:=1 to 8 do
    if work[x+10*y]=JOUEUR then
       with image1.picture.bitmap.canvas do
          begin
          brush.color:=clWhite ;
          ellipse((x-1)*30+5,(y-1)*30+5,(x-1)*30+25,(y-1)*30+25) ;
          end
    else
    if work[x+10*y]=ORDINATEUR then
       with image1.picture.bitmap.canvas do
          begin
          brush.color:=clBlack ;
          ellipse((x-1)*30+5,(y-1)*30+5,(x-1)*30+25,(y-1)*30+25) ;
          end ;
end ;

procedure TForm1.FormShow(Sender: TObject);
var i : integer ;
begin
image1.picture.bitmap:=tbitmap.create ;
with image1.picture.bitmap do
   begin
   width:=240 ;
   height:=240 ;
   canvas.brush.style:=bsSolid ;
   for i:=1 to 7 do
       with image1.picture.bitmap.canvas do
          begin
          moveto(i*30,0) ;lineto(i*30,240) ;
          moveto(0,i*30) ;lineto(240,i*30) ;
          end ;
   end ;
image1.autosize:=true ;
move(work0,work,100) ;fillchar(temoin,sizeof(temoin),#0) ;
affiche_jeu ;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
niveau_un ;
end;

end.
